#!/usr/bin/env python
# coding: utf-8

# In[55]:


# this doesn't seem to work; may have to reload jupyter notebook
get_ipython().system('pip3 install matplotlib')
get_ipython().system('pip3 install numba')
get_ipython().system('pip3 install opencv-python')
get_ipython().system('pip3 install seaborn')


# In[1]:


from platform import python_version
python_version()


# In[2]:


import numpy as np
from matplotlib import pyplot as plt
import pandas as pd

from numba import jit

import cv2 as cv



# In[3]:


work_path = "/home/linuxlite/workspace/"


# In[4]:


img = cv.imread(work_path + 'test_image.png', cv.IMREAD_COLOR)  #JUST READ IN COLOR CHANNELS, IGNORE ALPHA
Lut = cv.imread(work_path + 'Lab_LUT.png', cv.IMREAD_GRAYSCALE)  #should be single channel grayscale image

lab_x, lab_y = Lut.shape

print(lab_x, lab_y)

bgr_x, bgr_y, n_channels = img.shape
print(bgr_x, bgr_y, n_channels)


# In[5]:


# Convert BGR to HSV
#hsv = cv.cvtColor(img, cv.COLOR_BGR2HSV)
test_Lab = cv.cvtColor(img, cv.COLOR_BGR2Lab)

print(np.max(test_Lab[:,:,2]))


# In[6]:


#classify image using LUT
@jit(cache=True)  #mark function for numba compilation
def img2Lut(img, lut):
    n_rows, n_cols, n_channels = img.shape
    result = np.zeros((n_rows, n_cols))
    
    for i in range(n_rows):
       for j in range(n_cols):  # put cols on inside loop as it's 25% faster indexing this way
          result[i, j] = lut[img[i,j,1],img[i,j,2]]
    
    return result
   
    


# In[7]:


@jit(cache=True) 
def buildLut(Lab_img, lut):
    n_rows, n_cols, n_channels = img.shape
    
    
    
    for i in range(n_rows):
       for j in range(n_cols):  # put cols on inside loop as it's 25% faster indexing this way
          #get LUT table address (color is used as address)
          a = Lab_img[i,j,1]
          b = Lab_img[i,j,2]
          L = Lab_img[i,j,0]
          
          # set LUT location[a,b] to 255 to signify that color should be ignored
          lut[a, b] = 255
    
    return lut
    


# In[8]:


def img_proc(clr_img, Lut, area_thres=100):
   img_Lab = cv.cvtColor(clr_img, cv.COLOR_BGR2Lab)
   classified_img = img2Lut(img_Lab,Lut).astype(np.uint8) 
 
   #need to blobbify image
    
   # apply binary thresholding
   ret, thresh = cv.threshold(classified_img, 0, 100, cv.THRESH_BINARY_INV)

   # detect contours using green channel and without thresholding
#   contours2, hierarchy2 = cv.findContours(image=thresh, mode=cv.RETR_TREE, method=cv.cv2.CHAIN_APPROX_SIMPLE)
   contours2, hierarchy2 = cv.findContours(image=thresh, mode=cv.RETR_EXTERNAL, method=cv.cv2.CHAIN_APPROX_SIMPLE)
   #contours2, hierarchy2 = cv.findContours(image=thresh, mode=cv.RETR_LIST, method=cv.cv2.CHAIN_APPROX_SIMPLE)

   max_area = 0
   centroid = (-1,-1)
   cX = -1
   cY = -1
    
   area_list=[]
    
   indx = 0

   valid_contours = []
    
   for cntr in contours2:
      approx = cv.approxPolyDP(cntr, 0.009 * cv.arcLength(cntr, True), True)
      
      if(indx == 0):
         indx = indx + 1
         largest_contour = approx    #set 1st cntr as default largest 
            
      M = cv.moments(cntr)
      if(M["m00"] != 0):
         cX = int(M["m10"] / M["m00"])  #catch divide by zero 
         cY = int(M["m01"] / M["m00"])
    
      area = cv.contourArea(approx)
        
      if(area > area_thres):
          area_list.append(area)
          valid_contours.append(cntr)
        
      #perimeter = cv.arcLength(cntr,True)
      
      if(area > max_area):
         max_area = area
         largest_contour = approx
         centroid = (cX,cY)
   


   if(max_area > 0):
       cv.drawContours(clr_img, valid_contours, -1, (255,255,255), 2)

        
   return clr_img, thresh, max_area, centroid, area_list


# In[9]:


import matplotlib.pyplot as plt

def display_image_actual_size(im_data, title=""):
    
    #convert image to Lab color
    img_RGB = cv.cvtColor(im_data, cv.COLOR_BGR2RGB)


    dpi = 80
    #im_data = plt.imread(im_path)
    height, width, depth = img_RGB.shape

    # What size does the figure need to be in inches to fit the image?
    figsize = width / float(dpi), height / float(dpi)

    # Create a figure of the right size with one axes that takes up the full figure
    fig = plt.figure(figsize=figsize)
    ax = fig.add_axes([0, 0, 1, 1])

    # Hide spines, ticks, etc.
    ax.axis('on')

    ax.set_title(title)
    
    # Display the image.
    #ax.imshow(im_data, cmap='gray')
    ax.imshow(img_RGB)


    plt.show() 


# In[10]:


import matplotlib.pyplot as plt

def display_gray_image_actual_size(im_data, title=""):

    dpi = 80
    #im_data = plt.imread(im_path)
    height, width = im_data.shape

    # What size does the figure need to be in inches to fit the image?
    figsize = width / float(dpi), height / float(dpi)

    # Create a figure of the right size with one axes that takes up the full figure
    fig = plt.figure(figsize=figsize)
    ax = fig.add_axes([0, 0, 1, 1])

    # Hide spines, ticks, etc.
    ax.axis('on')

    # Display the image.
    #ax.imshow(im_data, cmap='gray')
    ax.imshow(im_data)
    
    ax.set_title(title)

    #plt.rcParams["figure.figsize"] = [7.50, 3.50]
    #plt.rcParams["figure.autolayout"] = True
    #plt.rcParams["axes.edgecolor"] = "black"
    #plt.rcParams["axes.linewidth"] = 2.50

    plt.imshow(im_data, cmap='Greys',  interpolation='nearest')

    #plt.show() 
    
    
    


# In[11]:


#scatter plot

def scatterPlot(x,y):
    #area is a vector, same size as x,y that holds z value, so each circle plotted is sized according to z
    #plt.scatter(x, y, s=area, c=colors, alpha=0.5)
    plt.scatter(x, y, alpha=0.5)
    plt.show()


# In[39]:


# processing time for single L LUT classifier
get_ipython().run_line_magic('timeit', 'img_proc(img,Lut)  #102ms/image without numba;  744usecs with numba')


# In[12]:


# build LUT
import glob

path = "/home/linuxlite/BlackPlastic/testing_lab_ginstand/image_with_cotton/"
path = "/home/linuxlite/BlackPlastic/testing_lab_ginstand/04_08_22_uncleaned_cotton_only/"


#read in image list
img_list = glob.glob(path + "*.png")


print(img_list)

print(len(img_list))




# In[13]:


path = "/home/linuxlite/BlackPlastic/video/yellow_plastic/"


#read in image list
plastic_img_list = glob.glob(path + "*.png")


print(plastic_img_list)

print(len(plastic_img_list))


# In[14]:


#split out list of imagePathNames into {tray, train, test}

tray_end = len(img_list)
tray_start = tray_end - 100

tray_image_list = img_list[tray_start:tray_end]

print()
print("tray image list length: ", len(tray_image_list))
print()

trunc_image_list = img_list[0:tray_start]
print("trunc image list length: ", len(trunc_image_list))
print()

import pandas as pd

#products_list = ['laptop', 'printer', 'tablet', 'desk', 'chair']
#df = pd.DataFrame (products_list, columns = ['product_name'])

#don't leave out column name or when you convert back to list, it creates list in list; makes it hard to extract string later
df_trunc_image_list = pd.DataFrame(trunc_image_list, columns = ['image names'])
df_trunc_image_list.head()

#create array (mask) of indexes
mask = np.random.rand(len(df_trunc_image_list)) < 0.30
                      

df_train_image_list = df_trunc_image_list[mask]

df_test_image_list = df_trunc_image_list[~mask]


#training_data = df[mask]
#testing_data = df[~mask]

print(f"No. of training examples: {len(df_train_image_list)}")
print(f"No. of testing examples: {len(df_test_image_list)}")


#convert df to list
train_image_list = df_train_image_list['image names'].tolist()
test_image_list = df_test_image_list['image names'].tolist()

print()
print("train image list length: ", len(train_image_list))
print("test image list length: ", len(test_image_list))

print()
print("tray image list item 0", tray_image_list[0])
print()
print("train image list item 0", train_image_list[0])


# In[175]:


#skip: test build and display LUT

#build LUT

#create blank LUT
Lab_LUT = np.zeros((256, 256))  # one pixel location for every value of 'a', 'b' in Lab image

imgName = img_list[10]
clr_img = cv.imread(imgName, cv.IMREAD_COLOR)  #JUST READ IN COLOR CHANNELS, IGNORE ALPHA

display_image_actual_size(clr_img)

#convert image to Lab color
img_Lab = cv.cvtColor(clr_img, cv.COLOR_BGR2Lab)

    
lut = buildLut(img_Lab, Lab_LUT)


display_gray_image_actual_size(lut)



# In[111]:


#skip: 

# changes to pd to allow us to view entire matrix

df = pd.DataFrame(lut)

# 1 way to display it all, is to convert data to string
#display(df.to_string())


#Better way:
#set pd display options to none so that it all displays
# Permanently changes the pandas settings
pd.set_option('display.max_rows', None)
pd.set_option('display.max_columns', None)
pd.set_option('display.width', None)
pd.set_option('display.max_colwidth', -1)

display(df)


# 
# 
# Odds are very different for random sampled images, versus "plastic-captured" images (where >8x in 2minutes is rare).
# for random sampled images odds are 8 (let's assume we miss 3 for every image captured), then it's 25 images/2minutes or 25plastic_images/(25*60*2images) = 25/3000 = 1:120 

# In[15]:


# Create LUT of the tray, as it's tray, no rejection criteria, can just build at will

# process all cotton images to build LUT
img_cnt = 0


#create blank LUTs
LUT = np.zeros((256, 256))  # one pixel location for every value of 'a', 'b' in Lab image


# interate through list of images
for imgName in tray_image_list:

    clr_img = cv.imread(imgName, cv.IMREAD_COLOR)  #JUST READ IN COLOR CHANNELS, IGNORE ALPHA
    
    #convert image to Lab color
    img_Lab = cv.cvtColor(clr_img, cv.COLOR_BGR2Lab)

    #must use same LUT so that you get append mode for classifier LUT build 
    LUT = buildLut(img_Lab, LUT)


#make deep copy of LUT     
LUT_tray = LUT.copy()
    
    

display_gray_image_actual_size(LUT_tray)


# In[18]:


# AutoCal BuildLUT. sample for 2 seconds: build LUT1, then repeat for LUT2; then add LUT1 & LUT2 and threshold --> LUT
# this removes transient colors from LUT


# process all cotton images to build LUT
img_cnt = 0

fps = 25
secs_per_sample = 1/25
num_frames = int(240 / secs_per_sample)

step = int(round((fps*secs_per_sample), 0)) # type: int
start = int(0) # type: int

span = len(train_image_list)

print("span: ", span)

n_cycles = 1
end = int(0)
          
          
step = int(round(( span/ n_cycles),0))

build_LUT_start = start #save copy of beginning of images for later use in validation testing

lut_list = []

    
for i in range(n_cycles):
    end += step # type: int

    print("start: ", start)
    print("end: ", end)

    #create blank LUTs
    LUT_SUM = np.zeros((256, 256))  # one pixel location for every value of 'a', 'b' in Lab image


    # interate through list of images
    for imgName in train_image_list[start:end]:
        #create blank LUTs
        Lab_LUT = np.zeros((256, 256))  # one pixel location for every value of 'a', 'b' in Lab image

        clr_img = cv.imread(imgName, cv.IMREAD_COLOR)  #JUST READ IN COLOR CHANNELS, IGNORE ALPHA
    
        #convert image to Lab color
        img_Lab = cv.cvtColor(clr_img, cv.COLOR_BGR2Lab)

        #must use same LUT so that you get append mode for classifier LUT build 
        LUT = buildLut(img_Lab, Lab_LUT)

        img_cnt +=  1
    
        #print(img_cnt)
       
        #KEEP TRACK OF WHICH COLORS WERE SELECTED IN THIS IMAGE
        #BY KEEPING A RUNNING SUM ON EACH COLOR SELECTED. (it'll be n*255 so to get n images divide by 255)
        LUT_SUM = np.add(LUT, LUT_SUM)


    #autocal threshold to enter == 20    
    threshold = 20*250 #very low probability (this assumes random sampling of images, not for use with plastic captured images)    
    #comparison with threshold turned-off
    threshold = 1*250 #very low probability (this assumes random sampling of images, not for use with plastic captured images)    

    #given color accepted into LUT if # of occurences > 6
    #ret, thresh = cv.threshold(classified_img, 0, 100, cv.THRESH_BINARY_INV)
    ret, accepted_LUT = cv.threshold(LUT_SUM, 0, threshold, cv.THRESH_BINARY)
        
    #make a deep copy of LUT, for later comparison
    lut_list.append(accepted_LUT.copy())
    
    start = end

#we now have several accepted_LUT's. final acceptance is to verify each color is in all 'i' accepted_LUT's 
    
lut_list_len = len(lut_list)
print("lut_list_len", lut_list_len)

#create LUT from deep copy of 1st LUT in list
#LUT = np.zeros((256, 256))  # one pixel location for every value of 'a', 'b' in Lab image
LUT = lut_list[0].copy()


if(n_cycles != 1):
    #iterate through entire list and only keep those colors that are in all LUT's
    for i in range(1,lut_list_len):
        LUT = cv.bitwise_and(LUT, lut_list[i])
        #LUT = np.add(LUT, lut_list[i])
    

#bitwise or with LUT_tray
LUT = cv.bitwise_or(LUT, LUT_tray)
    

display_gray_image_actual_size(LUT)


# now have to check performance of classifier; how well does it perform over same run of images that we just sampled to build LUT?

# In[16]:


# now test LUT on images you just used to build it (as they had different colors in them)

#process images with single LUT img_proc()

print()
print("start img_proc:")
print()

# ****************** AREA THRESHOLD ***********************
# Adjust to 500 for normal operation, or lower # if you want to truly see how well training classifier is working
area_thres = 100


global_area_list =[]
detected_count = 0
num_images_with_plastic = 0
singleLUT_images_with_plastic = []
singleLUT_images_without_plastic = []

indx = 0

start = 0
end = len(test_image_list)

num_images_to_process = end - start

print("start: ", start)
print("end: ", end)

for imgName in test_image_list[start:end]:
    
    indx += 1
    if(indx > num_images_to_process):
        break
    

        
    #imgName = img_list[10]
    clr_img = cv.imread(imgName, cv.IMREAD_COLOR)  #JUST READ IN COLOR CHANNELS, IGNORE ALPHA
    
    orig_clr_img = clr_img.copy()

    #display_image_actual_size(clr_img)


    # test against a known piece of plastic that's easy to classify
    classed_img, classified_binary_img, area, centroid, area_list = img_proc(clr_img, LUT, area_thres)

    #test against black plastic image
    #classed_img, classified_binary_img, area, centroid = img_proc(clr_img, lut)

    #print("area list count", len(area_list))
    
    for a in area_list:
        if(a > area_thres):
            detected_count += 1
            global_area_list.append(a)
    

    if(area > area_thres):
        num_images_with_plastic += 1
        singleLUT_images_with_plastic.append(imgName)  #add image name, id with plastic, to with_plastic list for later processing

        display_image_actual_size(orig_clr_img, "Classed Color Image with Object Recognized")
        display_image_actual_size(classed_img, "Classed Color Image with Object Recognized")
        print()
        print()
        print(imgName)
        print("process #: ", indx)
        print("detected count: ", detected_count)
        print("area: ", area)
        print("centroid: ", centroid)
        print("num images with plastic: ", num_images_with_plastic)
        print()
    else:
        singleLUT_images_without_plastic.append(imgName)  #add image name, id with plastic, to with_plastic list for later processing
        
        
    w,l = classified_binary_img.shape

    #display_gray_image_actual_size(classified_binary_img, "Binary Classed Image")
    

    

print("finished")

#process area_list
total_area = 0
for a in global_area_list:
    total_area += a
    

print("total area= ", total_area)




# so autocal is working; however now we have to prove it
# 
# Test:
# * Need to have plastic events clustered: (so they should happen at a higher rate than normal, so we get a decent test without waiting extrodinarially long time, and then when then do happen, the mode switches up the prob. to higher level, following Poisson distribution in time, with highest probability of occurring very quickly
# * randomly draw a pic from 1 of 2 pools {trashy-cotton <prob=0.99?>, plastic <prob=0.01?}
# 

# In[ ]:


# now test LUT on Plastic images 

#process images with single LUT img_proc()

print()
print("start plastic img_proc:")
print()

# ****************** AREA THRESHOLD ***********************
# Adjust to 500 for normal operation, or lower # if you want to truly see how well training classifier is working
area_thres = 100


global_area_list =[]
detected_count = 0
num_images_with_plastic = 0
singleLUT_images_with_plastic = []
singleLUT_images_without_plastic = []

indx = 0

start = 1000
end = len(plastic_img_list)
end = 6000

num_images_to_process = end - start

print("start: ", start)
print("end: ", end)

for imgName in plastic_img_list[start:end]:
    
    indx += 1
    if(indx > num_images_to_process):
        break
    

        
    #imgName = img_list[10]
    clr_img = cv.imread(imgName, cv.IMREAD_COLOR)  #JUST READ IN COLOR CHANNELS, IGNORE ALPHA
    
    orig_clr_img = clr_img.copy()

    #display_image_actual_size(clr_img)


    # test against a known piece of plastic that's easy to classify
    classed_img, classified_binary_img, area, centroid, area_list = img_proc(clr_img, LUT, area_thres)

    #test against black plastic image
    #classed_img, classified_binary_img, area, centroid = img_proc(clr_img, lut)

    #print("area list count", len(area_list))
    
    for a in area_list:
        if(a > area_thres):
            detected_count += 1
            global_area_list.append(a)
    

    if(area > area_thres):
        num_images_with_plastic += 1
        singleLUT_images_with_plastic.append(imgName)  #add image name, id with plastic, to with_plastic list for later processing

        display_image_actual_size(orig_clr_img, "Classed Color Image with Object Recognized")
        display_image_actual_size(classed_img, "Classed Color Image with Object Recognized")
        print()
        print()
        print(imgName)
        print("process #: ", indx)
        print("detected count: ", detected_count)
        print("area: ", area)
        print("centroid: ", centroid)
        print("num images with plastic: ", num_images_with_plastic)
        print()
    else:
        singleLUT_images_without_plastic.append(imgName)  #add image name, id with plastic, to with_plastic list for later processing
        
        
    w,l = classified_binary_img.shape

    #display_gray_image_actual_size(classified_binary_img, "Binary Classed Image")
    

    

print("finished")

#process area_list
total_area = 0
for a in global_area_list:
    total_area += a
    

print("total area= ", total_area)


# In[ ]:





# In[27]:


# generate random arrival times, that follow a Poisson Process with expected events spaced at mean of 15 secs

#expected # of events (in minutes)
lambda_mins = 3.52
lambda_secs = lambda_mins * 60
num_events = 20
events = np.random.poisson(lambda_secs, num_events)

print(events)


# In[28]:


#note that each event is independant from previous one; so time series can be achieved by running cum sum

times = []
cur_time = 0

for k in events:
    cur_time += k / 60.0
    times.append(cur_time)
    
print(times)


# In[ ]:


#now plot:
plt.


# In[ ]:





# In[ ]:





# In[ ]:





# In[ ]:





# In[ ]:





# In[ ]:





# In[ ]:





# In[ ]:





# In[ ]:





# In[ ]:





# In[ ]:





# In[ ]:





# In[43]:


# now run on images that have black plastic in them

path = "/home/linuxlite/BlackPlastic/testing_lab_ginstand/image_black_plastic/"


#read in image list
img_list = glob.glob(path + "*.png")


print(img_list)

print(len(img_list))


# In[44]:


imgName = img_list[10]
clr_img = cv.imread(imgName, cv.IMREAD_COLOR)  #JUST READ IN COLOR CHANNELS, IGNORE ALPHA

display_image_actual_size(clr_img)


# In[45]:


# class using img_proc (single L negative classifier)

#1st try with color plastic
img = cv.imread(work_path + 'test_image.png', cv.IMREAD_COLOR)

#2nd try with black plastic (note this will give an error because it doesn't find any objects; needs same fix as we did in multi-below or don't worry about it)
#imgName = img_list[10]
#img = cv.imread(imgName, cv.IMREAD_COLOR)  #JUST READ IN COLOR CHANNELS, IGNORE ALPHA



display_image_actual_size(img, "Raw Color Image")


# test against a known piece of plastic that's easy to classify
classed_img, classified_binary_img, area, centroid, area_list = img_proc(img, lut)

#test against black plastic image
#classed_img, classified_binary_img, area, centroid = img_proc(clr_img, lut)



print("area: ", area)
print("centroid: ", centroid)

display_image_actual_size(classed_img, "Classed Color Image with Object Recognized")

w,l = classified_binary_img.shape

display_gray_image_actual_size(classified_binary_img, "Binary Classed Image")


# so good strong evidence that our negative classifier will not work for black plastic
# 
# will need to try a different approach.
# 
# next step: try a multi-L LUT
# 
# 

# In[46]:


#now lets compare difference between single and multiLUT for 

# get list of images that have pink plastic in them

path = "/home/linuxlite/BlackPlastic/video/pink_plastic/"
path = "/home/linuxlite/BlackPlastic/video/yellow_2x2_size/run1/"


#read in image list
img_list = glob.glob(path + "*.png")


print(img_list)

print(len(img_list))


# In[47]:


#process images with single LUT img_proc()

print()
print("start img_proc:")
print()

area_thres = 10
global_area_list =[]
detected_count = 0
num_images_with_plastic = 0
singleLUT_images_with_plastic = []
singleLUT_images_without_plastic = []

num_images_to_process = 3000
indx = 0

for imgName in img_list:
    
    indx += 1
    if(indx > num_images_to_process):
        break
    

        
    #imgName = img_list[10]
    clr_img = cv.imread(imgName, cv.IMREAD_COLOR)  #JUST READ IN COLOR CHANNELS, IGNORE ALPHA
    
    orig_clr_img = clr_img.copy()

    #display_image_actual_size(clr_img)


    # test against a known piece of plastic that's easy to classify
    classed_img, classified_binary_img, area, centroid, area_list = img_proc(clr_img, lut, area_thres)

    #test against black plastic image
    #classed_img, classified_binary_img, area, centroid = img_proc(clr_img, lut)

    #print("area list count", len(area_list))
    
    for a in area_list:
        if(a > area_thres):
            detected_count += 1
            global_area_list.append(a)
    

    if(area > area_thres):
        num_images_with_plastic += 1
        singleLUT_images_with_plastic.append(imgName)  #add image name, id with plastic, to with_plastic list for later processing

        display_image_actual_size(orig_clr_img, "Classed Color Image with Object Recognized")
        display_image_actual_size(classed_img, "Classed Color Image with Object Recognized")
        print()
        print()
        print(imgName)
        print("process #: ", indx)
        print("detected count: ", detected_count)
        print("area: ", area)
        print("centroid: ", centroid)
        print("num images with plastic: ", num_images_with_plastic)
        print()
    else:
        singleLUT_images_without_plastic.append(imgName)  #add image name, id with plastic, to with_plastic list for later processing
        
        
    w,l = classified_binary_img.shape

    #display_gray_image_actual_size(classified_binary_img, "Binary Classed Image")
    

    

print("finished")

#process area_list
total_area = 0
for a in global_area_list:
    total_area += a
    

print("total area= ", total_area)


# In[ ]:





# AutoCal, 
# 
# in buildLUT_autoCal; need to keep track of # of occurences of a given color
# 

# In[ ]:





# In[ ]:





# In[ ]:





# In[159]:


#make a copy of images identified with plastic
import os
import shutil
import sys

# organize dataset into a useful structure
from os import makedirs
from os import listdir
from shutil import copyfile
from random import seed
from random import random




# In[162]:


dest_plastic_directory = "/home/linuxlite/BlackPlastic/video/id_as_pink_plastic/"

print("# plastic images: ", len(images_with_plastic))

for img in images_with_plastic:
    src = img
    fileName = os.path.basename(img)
    
    destination = dest_plastic_directory + fileName
    
    try:
        shutil.copy(src, destination)
    except:
        pass
    
   


# In[163]:


dest_noPlastic_directory = "/home/linuxlite/BlackPlastic/video/id_as_pink_noPlastic/"

print("# no-plastic images: ", len(images_without_plastic))

    
for img in images_without_plastic:
    src = img
    fileName = os.path.basename(img)
    
    destination = dest_noPlastic_directory + fileName
    
    try:
        shutil.copy(src, destination)
    except:
        pass


# In[ ]:


# examine what part of these images are being captured
#process images with single-LUT img_proc()

print()
print("start single-LUT img_proc:")
print()

area_thres = 100
global_area_list =[]
sp_singleLUT_images_with_plastic = []
sp_singleLUT_images_without_plastic = []
detected_count = 0
num_images_with_plastic = 0

num_images_to_process = 300
indx = 0

for imgName in only_multiLUT_detected_images:
    
    indx += 1
    if(indx > num_images_to_process):
        break
    
    print()
    print()
    print(imgName)

        
    #imgName = img_list[10]
    clr_img = cv.imread(imgName, cv.IMREAD_COLOR)  #JUST READ IN COLOR CHANNELS, IGNORE ALPHA



    # test against a known piece of plastic that's easy to classify
    #classed_img, classified_binary_img, area, centroid, area_list = img_proc_multi(clr_img, LUT1, LUT2, LUT3, LUT4, LUT5, area_thres)
    classed_img, classified_binary_img, area, centroid, area_list = img_proc(clr_img, lut, area_thres)

    #test against black plastic image
    #classed_img, classified_binary_img, area, centroid = img_proc(clr_img, lut)

    print("area list count", len(area_list))
    
    for a in area_list:
        if(a > area_thres):
            detected_count += 1
            global_area_list.append(a)
    

    if(area > area_thres):
        num_images_with_plastic += 1
        sp_singleLUT_images_with_plastic.append(imgName)  #add image name, id with plastic, to with_plastic list for later processing
    else:
        sp_singleLUT_images_without_plastic.append(imgName) #add image name, id with plastic, to without_plastic list for later processin
        

    if(area > area_thres):
        #display_image_actual_size(clr_img)
        display_image_actual_size(classed_img, "Classed Color Image with Object Recognized")

    w,l = classified_binary_img.shape

    #display_gray_image_actual_size(classified_binary_img, "Binary Classed Image")
    
    print("process #: ", indx)
    print("detected count: ", detected_count)
    print("area: ", area)
    print("centroid: ", centroid)
    print("num images with plastic: ", num_images_with_plastic)
    print()

    

print("finished")

