#!/usr/bin/env python
# coding: utf-8

# In[4]:


# this doesn't seem to work; may have to reload jupyter notebook
get_ipython().system('pip3 install matplotlib')
get_ipython().system('pip3 install numba')
get_ipython().system('pip3 install opencv-python')


# In[1]:


from platform import python_version
python_version()


# In[2]:


import numpy as np
from matplotlib import pyplot as plt

from numba import jit

import cv2 as cv



# In[3]:


work_path = "/home/linuxlite/workspace/"


# In[4]:


img = cv.imread(work_path + 'test_image.png', cv.IMREAD_COLOR)  #JUST READ IN COLOR CHANNELS, IGNORE ALPHA
Lut = cv.imread(work_path + 'Lab_LUT.png', cv.IMREAD_GRAYSCALE)  #should be single channel grayscale image

lab_x, lab_y = Lut.shape

print(lab_x, lab_y)

bgr_x, bgr_y, n_channels = img.shape
print(bgr_x, bgr_y, n_channels)


# In[5]:


# Convert BGR to HSV
#hsv = cv.cvtColor(img, cv.COLOR_BGR2HSV)
test_Lab = cv.cvtColor(img, cv.COLOR_BGR2Lab)

print(np.max(test_Lab[:,:,2]))


# In[6]:


@jit(cache=True)  #mark function for numba compilation
def img2Lut(img, lut):
    n_rows, n_cols, n_channels = img.shape
    result = np.zeros((n_rows, n_cols))
    
    for i in range(n_rows):
       for j in range(n_cols):  # put cols on inside loop as it's 25% faster indexing this way
          result[i, j] = lut[img[i,j,1],img[i,j,2]]
    
    return result
   
    


# In[7]:


L1_thres = 10
L2_thres = 20
L3_thres = 30
L4_thres = 40
L5_thres = 250



# In[8]:


@jit(cache=True)  #mark function for numba compilation
def img2_multiLut(img, LUT1, LUT2, LUT3, LUT4, LUT5):
    n_rows, n_cols, n_channels = img.shape
    result = np.zeros((n_rows, n_cols))
    
    for i in range(n_rows):
       for j in range(n_cols):  # put cols on inside loop as it's 25% faster indexing this way
          L = img[i,j,0]
          
          if(L <= L1_thres):
             result[i, j] = LUT1[img[i,j,1],img[i,j,2]]
          elif(L <= L2_thres):
             result[i, j] = LUT2[img[i,j,1],img[i,j,2]]
          elif(L <= L3_thres):
             result[i, j] = LUT3[img[i,j,1],img[i,j,2]]
          elif(L <= L4_thres):
             result[i, j] = LUT4[img[i,j,1],img[i,j,2]]
          elif(L <= L5_thres):
             result[i, j] = LUT5[img[i,j,1],img[i,j,2]]
          else:
             result[i, j] = LUT5[img[i,j,1],img[i,j,2]]

    return result


# In[9]:


@jit(cache=True) 
def buildLut(Lab_img, lut):
    n_rows, n_cols, n_channels = img.shape
    
    
    
    for i in range(n_rows):
       for j in range(n_cols):  # put cols on inside loop as it's 25% faster indexing this way
          a = Lab_img[i,j,1]
          b = Lab_img[i,j,2]
          L = Lab_img[i,j,0]
          
          lut[a, b] = 255
    
    return lut
    


# In[10]:


@jit(cache=True) 
def build_multiLut(Lab_img, LUT1, LUT2, LUT3, LUT4, LUT5):
    n_rows, n_cols, n_channels = img.shape
    
    
    for i in range(n_rows):
       for j in range(n_cols):  # put cols on inside loop as it's 25% faster indexing this way
          a = Lab_img[i,j,1]
          b = Lab_img[i,j,2]
          L = Lab_img[i,j,0]
          
          if(L <= L1_thres):
             LUT1[a,b] = 255
          elif(L <= L2_thres):
             LUT2[a,b] = 255
          elif(L <= L3_thres):
             LUT3[a,b] = 255
          elif(L <= L4_thres):
             LUT4[a,b] = 255
          elif(L <= L5_thres):
             LUT5[a,b] = 255
          else:
             LUT5[a,b] = 255  #ignore if saturated
    
    #return lut1, lut2, lut3, lut4, lut5


# In[30]:


def img_proc(clr_img, Lut):
   img_Lab = cv.cvtColor(clr_img, cv.COLOR_BGR2Lab)
   classified_img = img2Lut(img_Lab,Lut).astype(np.uint8) 
 
   #need to blobbify image
    
   # apply binary thresholding
   ret, thresh = cv.threshold(classified_img, 0, 100, cv.THRESH_BINARY_INV)

   # detect contours using green channel and without thresholding
   contours2, hierarchy2 = cv.findContours(image=thresh, mode=cv.RETR_TREE, method=cv.cv2.CHAIN_APPROX_SIMPLE)

   max_area = 0
   centroid = (-1,-1)
   cX = -1
   cY = -1
    
   indx = 0
   for cntr in contours2:
      approx = cv.approxPolyDP(cntr, 0.009 * cv.arcLength(cntr, True), True)
      
      if(indx == 0):
         indx = indx + 1
         largest_contour = approx    #set 1st cntr as default largest 
            
      M = cv.moments(cntr)
      if(M["m00"] != 0):
         cX = int(M["m10"] / M["m00"])  #catch divide by zero 
         cY = int(M["m01"] / M["m00"])
    
      area = cv.contourArea(approx)
      #perimeter = cv.arcLength(cntr,True)
      
      if(area > max_area):
         max_area = area
         largest_contour = approx
         centroid = (cX,cY)
   
   #cv.drawContours(img, contours, -1, (255,0,0), 20)
   if(indx>=1):
       cv.drawContours(clr_img, [largest_contour], -1, (255,255,255), 2)
        
   return clr_img, thresh, max_area, centroid


# In[12]:


def img_proc_multi(clr_img, LUT1, LUT2, LUT3, LUT4, LUT5):
   img_Lab = cv.cvtColor(clr_img, cv.COLOR_BGR2Lab)
   classified_img = img2_multiLut(img_Lab, LUT1, LUT2, LUT3, LUT4, LUT5).astype(np.uint8) 
 
   #need to blobbify image
    
   # apply binary thresholding
   ret, thresh = cv.threshold(classified_img, 0, 100, cv.THRESH_BINARY_INV)

   # detect contours using green channel and without thresholding
   contours2, hierarchy2 = cv.findContours(image=thresh, mode=cv.RETR_TREE, method=cv.cv2.CHAIN_APPROX_SIMPLE)

   max_area = 0
   centroid = (-1,-1)
   cX = -1
   cY = -1
    
   indx = 0
   for cntr in contours2:
      approx = cv.approxPolyDP(cntr, 0.009 * cv.arcLength(cntr, True), True)
      
      if(indx == 0):
         indx = indx + 1
         largest_contour = approx    #set 1st cntr as default largest 
            
      M = cv.moments(cntr)
      if(M["m00"] != 0):
         cX = int(M["m10"] / M["m00"])  #catch divide by zero 
         cY = int(M["m01"] / M["m00"])
    
      area = cv.contourArea(approx)
      #perimeter = cv.arcLength(cntr,True)
      
      if(area > max_area):
         max_area = area
         largest_contour = approx
         centroid = (cX,cY)
   
   #cv.drawContours(img, contours, -1, (255,0,0), 20)
   if(indx >= 1): 
       cv.drawContours(clr_img, [largest_contour], -1, (255,255,255), 2)
   return clr_img, thresh, max_area, centroid


# In[ ]:


import numpy as np
#from sklearn.base import RegressorMixin
from sklearn.base import ClassifierMixin

class NullClassifier(ClassifierMixin):
    def __init__(self, *args, **args):
        self.model = KMeans(*args, **args)
        self.y_bar = 0

    def fit(self, X=None, y=None):
        # The prediction will always just be the mean of y
        self.y_bar_ = np.mean(y)
    def predict(self, X=None):
        # Give back the mean of y, in the same
        # length as the number of X observations
        return np.ones(X.shape[0]) * self.y_bar_
    
    

    


# In[13]:


import matplotlib.pyplot as plt

def display_image_actual_size(im_data, title=""):

    dpi = 80
    #im_data = plt.imread(im_path)
    height, width, depth = im_data.shape

    # What size does the figure need to be in inches to fit the image?
    figsize = width / float(dpi), height / float(dpi)

    # Create a figure of the right size with one axes that takes up the full figure
    fig = plt.figure(figsize=figsize)
    ax = fig.add_axes([0, 0, 1, 1])

    # Hide spines, ticks, etc.
    ax.axis('on')

    ax.set_title(title)
    
    # Display the image.
    #ax.imshow(im_data, cmap='gray')
    ax.imshow(im_data)


    plt.show() 


# In[14]:


import matplotlib.pyplot as plt

def display_gray_image_actual_size(im_data, title=""):

    dpi = 80
    #im_data = plt.imread(im_path)
    height, width = im_data.shape

    # What size does the figure need to be in inches to fit the image?
    figsize = width / float(dpi), height / float(dpi)

    # Create a figure of the right size with one axes that takes up the full figure
    fig = plt.figure(figsize=figsize)
    ax = fig.add_axes([0, 0, 1, 1])

    # Hide spines, ticks, etc.
    ax.axis('on')

    # Display the image.
    #ax.imshow(im_data, cmap='gray')
    ax.imshow(im_data)
    
    ax.set_title(title)

    #plt.rcParams["figure.figsize"] = [7.50, 3.50]
    #plt.rcParams["figure.autolayout"] = True
    #plt.rcParams["axes.edgecolor"] = "black"
    #plt.rcParams["axes.linewidth"] = 2.50

    plt.imshow(im_data, cmap='Greys',  interpolation='nearest')

    #plt.show() 
    
    
    


# In[15]:


# processing time for single L LUT classifier
get_ipython().run_line_magic('timeit', 'img_proc(img,Lut)  #102ms/image without numba;  744usecs with numba')


# In[15]:


#create blank LUT
LUT1 = np.zeros((256, 256))  # one pixel location for every value of 'a', 'b' in Lab image
LUT2 = np.zeros((256, 256))  # one pixel location for every value of 'a', 'b' in Lab image
LUT3 = np.zeros((256, 256))  # one pixel location for every value of 'a', 'b' in Lab image
LUT4 = np.zeros((256, 256))  # one pixel location for every value of 'a', 'b' in Lab image
LUT5 = np.zeros((256, 256))  # one pixel location for every value of 'a', 'b' in Lab image
 

# processing time for multi-level L LUT classifier
#%timeit img_proc_multi(img, LUT1, LUT2, LUT3, LUT4, LUT5)  #102ms/image without numba;  744usecs with numba


# In[16]:


# build LUT
import glob

path = "/home/linuxlite/BlackPlastic/testing_lab_ginstand/image_with_cotton/"

#create blank LUT
Lab_LUT = np.zeros((256, 256))  # one pixel location for every value of 'a', 'b' in Lab image

#read in image list
img_list = glob.glob(path + "*.png")


print(img_list)

print(len(img_list))




# In[17]:


#build LUT
imgName = img_list[10]
clr_img = cv.imread(imgName, cv.IMREAD_COLOR)  #JUST READ IN COLOR CHANNELS, IGNORE ALPHA

display_image_actual_size(clr_img)

#convert image to Lab color
img_Lab = cv.cvtColor(clr_img, cv.COLOR_BGR2Lab)

    
lut = buildLut(img_Lab, Lab_LUT)


display_gray_image_actual_size(lut)



# In[18]:


# build Multi-LUT

imgName = img_list[10]
clr_img = cv.imread(imgName, cv.IMREAD_COLOR)  #JUST READ IN COLOR CHANNELS, IGNORE ALPHA

display_image_actual_size(clr_img)

#convert image to Lab color
img_Lab = cv.cvtColor(clr_img, cv.COLOR_BGR2Lab)

    
build_multiLut(img_Lab, LUT1, LUT2, LUT3, LUT4, LUT5)


display_gray_image_actual_size(LUT1)
print()
display_gray_image_actual_size(LUT2)
print()
display_gray_image_actual_size(LUT3)
print()
display_gray_image_actual_size(LUT4)
print()
display_gray_image_actual_size(LUT5)
print()



# In[19]:


# process all cotton images to build LUT
img_cnt = 0

# interate through list of images
for imgName in img_list:
   clr_img = cv.imread(imgName, cv.IMREAD_COLOR)  #JUST READ IN COLOR CHANNELS, IGNORE ALPHA
    
   #convert image to Lab color
   img_Lab = cv.cvtColor(clr_img, cv.COLOR_BGR2Lab)

    
   lut = buildLut(img_Lab, Lab_LUT)

   img_cnt +=  1
    
   print(img_cnt)


display_gray_image_actual_size(lut)


# In[20]:


# process all cotton images to build multiLUT
img_cnt = 0

print(img_list[0])
print()

# interate through list of images
for imgName in img_list:
   clr_img = cv.imread(imgName, cv.IMREAD_COLOR)  #JUST READ IN COLOR CHANNELS, IGNORE ALPHA
    
   #convert image to Lab color
   img_Lab = cv.cvtColor(clr_img, cv.COLOR_BGR2Lab)

   #uses global variables for the LUTx 
   build_multiLut(img_Lab, LUT1, LUT2, LUT3, LUT4, LUT5)

   img_cnt += 1
    
   print(img_cnt)


display_gray_image_actual_size(LUT1)
print()
display_gray_image_actual_size(LUT2)
print()
display_gray_image_actual_size(LUT3)
print()
display_gray_image_actual_size(LUT4)
print()
display_gray_image_actual_size(LUT5)
print()


# In[21]:


# now run on images that have black plastic in them

path = "/home/linuxlite/BlackPlastic/testing_lab_ginstand/image_black_plastic/"


#read in image list
img_list = glob.glob(path + "*.png")


print(img_list)

print(len(img_list))


# In[22]:


imgName = img_list[10]
clr_img = cv.imread(imgName, cv.IMREAD_COLOR)  #JUST READ IN COLOR CHANNELS, IGNORE ALPHA

display_image_actual_size(clr_img)


# In[23]:


# class using img_proc (single L negative classifier)

#1st try with color plastic
img = cv.imread(work_path + 'test_image.png', cv.IMREAD_COLOR)

#2nd try with black plastic (note this will give an error because it doesn't find any objects; needs same fix as we did in multi-below or don't worry about it)
#imgName = img_list[10]
#img = cv.imread(imgName, cv.IMREAD_COLOR)  #JUST READ IN COLOR CHANNELS, IGNORE ALPHA



display_image_actual_size(img, "Raw Color Image")


# test against a known piece of plastic that's easy to classify
classed_img, classified_binary_img, area, centroid = img_proc(img, lut)

#test against black plastic image
#classed_img, classified_binary_img, area, centroid = img_proc(clr_img, lut)



print("area: ", area)
print("centroid: ", centroid)

display_image_actual_size(classed_img, "Classed Color Image with Object Recognized")

w,l = classified_binary_img.shape

display_gray_image_actual_size(classified_binary_img, "Binary Classed Image")


# so good strong evidence that our negative classifier will not work for black plastic
# 
# will need to try a different approach.
# 
# next step: try a multi-L LUT
# 
# 

# In[24]:


# class using img_proc_multi (multi-level L negative classifier)

#1st try with color plastic
img = cv.imread(work_path + 'test_image.png', cv.IMREAD_COLOR)

#2nd try with black plastic
#imgName = img_list[10]
#img = cv.imread(imgName, cv.IMREAD_COLOR)  #JUST READ IN COLOR CHANNELS, IGNORE ALPHA




display_image_actual_size(img, "Raw Color Image")


# test against a known piece of plastic that's easy to classify
classed_img, classified_binary_img, area, centroid = img_proc_multi(img, LUT1, LUT2, LUT3, LUT4, LUT5)

#test against black plastic image
#classed_img, classified_binary_img, area, centroid = img_proc_multi(clr_img, LUT1, LUT2, LUT3, LUT4, LUT5)



print("area: ", area)
print("centroid: ", centroid)

display_image_actual_size(classed_img, "Classed Color Image with Object Recognized")

w,l = classified_binary_img.shape

display_gray_image_actual_size(classified_binary_img, "Binary Classed Image")


# Tried multiple versions of a 5 LUT classifier (with change being various levels hieights of L bands for each LUT)
# 
# result was a distinct color (cyan) can be classified, but black was not classified by any of them
# 
# Time to punt and move on to Deep Learning
# 
# 
# note: for our current system; good probability it will improve if we add multiple L LUT's (assuming it doesn't slow it down too much...

# In[25]:


# save LUT
cv.imwrite('/home/linuxlite/LUT1.png',LUT1)
cv.imwrite('/home/linuxlite/LUT2.png',LUT2)
cv.imwrite('/home/linuxlite/LUT3.png',LUT3)
cv.imwrite('/home/linuxlite/LUT4.png',LUT4)
cv.imwrite('/home/linuxlite/LUT5.png',LUT5)



# In[26]:


#now lets compare difference between single and multiLUT for 

# get list of images that have pink plastic in them

path = "/home/linuxlite/BlackPlastic/video/pink_plastic/"


#read in image list
img_list = glob.glob(path + "*.png")


print(img_list)

print(len(img_list))


# In[31]:


print()
print("start img_proc:")
print()

area_list =[]
detected_count = 0

for imgName in img_list:
    #imgName = img_list[10]
    clr_img = cv.imread(imgName, cv.IMREAD_COLOR)  #JUST READ IN COLOR CHANNELS, IGNORE ALPHA

    display_image_actual_size(clr_img)


    # test against a known piece of plastic that's easy to classify
    classed_img, classified_binary_img, area, centroid = img_proc(clr_img, lut)

    #test against black plastic image
    #classed_img, classified_binary_img, area, centroid = img_proc(clr_img, lut)

    if(area > 0):
        detected_count += 1
    
    
    area_list.append(area)
    

    print(imgName)
    print("detected count: ", detected_count)
    print("area: ", area)
    print("centroid: ", centroid)
    print()

    display_image_actual_size(classed_img, "Classed Color Image with Object Recognized")

    w,l = classified_binary_img.shape

    display_gray_image_actual_size(classified_binary_img, "Binary Classed Image")


# In[ ]:




